#include <cassert>
#include <fstream>
#include <string>
#include <stdio.h>

using namespace std;

const int MAX_M = 10000;
const int MAX_N = 10000;
int m, n;
int field[MAX_M][MAX_N];

int main() {
	int num_odd_components = 0;
	
	ifstream fin("input.txt"); assert( fin );
	fin >> m >> n;

	string line; getline(fin, line);
	for(int i = 0; i < m; i++) {
		getline(fin, line);

		size_t pos;
		pos = line.find("1");
//		if (pos != std::string::npos)
//			std::cout << "posOK: " << pos << std::endl;

		while (pos < n+n-5) {
//			pos = line.find("1 0 0");
			for(size_t pos = line.find("1 0 0"); pos != std::string::npos; pos = line.find("1 0 0", pos)) {
				line.replace(pos, 5, "0 1 1");
				pos += 5;
			}
			for(size_t pos = line.find("1 1 1"); pos != std::string::npos; pos = line.find("1 1 1", pos)) {
				line.replace(pos, 5, "0 0 0");
				pos += 5;
			}
			for(size_t pos = line.find("1 1 0"); pos != std::string::npos; pos = line.find("1 1 0", pos)) {
				line.replace(pos, 5, "0 0 1");
				pos += 5;
			}
			for(size_t pos = line.find("1 0 1"); pos != std::string::npos; pos = line.find("1 0 1", pos)) {
				line.replace(pos, 5, "0 1 0");
				pos += 5;
			}
			
			pos = line.find("1");
		}
//		std::cout << "line: " << line << std::endl;

		pos = line.find("1");
		if(pos != std::string::npos) num_odd_components++;
		
//		const char *p = line.c_str();
//		for(int j = 0; j < n; j++) {
//			while( *p < '0' ) p++;
//			field[i][j] = *p - '0'; p++;
//		}
	}
	fin.close();
	
//	cout << "\n\n";
//	for(int i = 0; i < m; i++) {
//		for(int j = 0; j < n; j++) 
//			cout << field[i][j] << " ";
//		cout << "\n";
//	}
//	cout << "\n";
	

//	cout << num_odd_components << endl;
	ofstream fout("output.txt"); assert( fout );
	fout << num_odd_components << endl;
	fout.close();
	return 0;
}
