#include <stdio.h>
#include <assert.h>
#include <fstream>
#include <vector>
#include <string>
#include <sstream>

using namespace std;

string result;

string convert_int(int number){
    stringstream ss;
    ss << number;
    return ss.str();
}

void reverse(int from, int to, vector<int> tree){
    assert(from >= 0);

    result.append(convert_int(tree[from]));
    result.append(" ");

    int prevto=to;
    int i, childs, k;

    for(childs=tree[from]; childs > 0;childs--){
        k=childs-1;
        i=from;
        while(k>0){
            i++;
            k--;
            k+=tree[i];        
        }

        reverse(i+1, prevto, tree);
        prevto=i;
    }
}

int main(){
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    vector<int> v;
    int i;

    while(fin.good()){
        fin >> i;
        v.push_back(i);        
    }

    reverse(0, v.size(), v);

    fout << result << endl;
   
}
