#include <stdio.h>
#include <iostream>
#include <assert.h>
#include <fstream>
#include <vector>
#include <string>
#include <sstream>
#include <climits>
#include <numeric>

using namespace std;

vector<vector<int> > matrix;
int min_val = INT_MAX;
int sum =0;

vector<int> stomp(vector<int> v, int beg){
    if(v[beg] == 0)
        v[beg] = 1;
    else
        v[beg]=0;

    if(v[beg+1] == 0)
        v[beg+1] = 1;
    else
        v[beg+1]=0;

    if(v[beg+2] == 0)
        v[beg+2] = 1;
    else
        v[beg+2]=0;

    return v;
}

vector<int> visit(vector<int> v, int beg){

    if((beg + 2 >= v.size()) || (beg < 0) || min_val == 0){
        return v;
    }

    v=stomp(v, beg);
    int tmp = accumulate(v.begin(), v.end(), 0);


    if(tmp < min_val) min_val=tmp;
    
    return visit(v, beg+1);
}

int main(){

    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n, m;

    fin >> n; fin >> m;

    vector<vector<int> > t(n, vector<int>(m));

    matrix=t;

    for(int i=0; i<n; i++){
            for(int j=0; j<m; j++){
                fin >> matrix[i][j];
            }
    }

bool sent = true;

    for(int i=0; i<n; ++i){
        
        vector<int> t(matrix[i]);

        sent = true; int j=0;

        if(accumulate(t.begin(), t.end(), 0) == m || accumulate(t.begin(), t.end(), 0) == 0){
            sum+=0;
            continue;
        }
        while(sent){

            t=visit(t, 0);
            t=visit(t, 0);
            t=visit(t, 0);

            if(min_val <= n){
                sent = false;
                sum += min_val;
                min_val = INT_MAX;  
            }                
        }
    }
    
    fout << sum << endl;

}
