#include <cstdlib>
#include <fstream>
#include <cassert>
#include <algorithm>
#include <limits.h>


using namespace std;

ofstream fout;
ifstream fin;

struct nodo{
    nodo *padre;
    int nfigli;
    int nodiVisitati;
    nodo *nodi;
};

int main(){
    int n,i,cnt;
    struct nodo *radice = new nodo;
    struct nodo *corrente = radice;
    corrente->padre = NULL;
    n = 0;
    cnt = 0;
    fin.open("input.txt");
    while(cnt == 0){
        fin >> corrente->nfigli;
        n++;
        corrente->nodi = new nodo[corrente->nfigli];
        corrente->nodiVisitati = 0;
        // setto il padre
        for(i = 0; i < corrente->nfigli; i++){
            (corrente->nodi[i]).padre = corrente;
        }
        // vado al prossimo nodo da elaborare
        while(1){
          
            if(corrente->nodiVisitati != corrente->nfigli){
                 corrente->nodiVisitati++;
                 corrente = &(corrente->nodi[corrente->nodiVisitati - 1]);  
                break;          
            }else{
                if(corrente->padre != NULL){
                    corrente = (corrente->padre);
                }
                else{
                    cnt = 1;
                    break;
                }
            }
        }
    }
    fin.close();

    fout.open("output.txt");

    // visito l'albero
    fout << radice->nfigli << " ";
    corrente = radice;
    n--;
    while(n > 0){
        if(corrente->nfigli != 0 && corrente->nodiVisitati > 0){
            corrente->nodiVisitati--;
            corrente = &(corrente->nodi[corrente->nodiVisitati]);
            fout << corrente->nfigli << " ";
            n--;
        }
        else{
            if(n != 0){
                corrente=corrente->padre;
                while(corrente->nodiVisitati == 0){
                    corrente=corrente->padre;
                }
            }
            else
                break;    
        }
    }
    fout.close();
    return 0;
}
